#include"kraluk.h"

void vetyslova ()
{
  dvere     = add_word(0);
  strom     = add_word(0);
  muz       = add_word(0);
  zemisto   = add_word(1);
  voda      = add_word(0);
  tresne    = add_word(0);
  divka     = add_word(0);
  smolicek  = add_word(0);
  jelen     = add_word(0);
  krkavci   = add_word(0);
  kral      = add_word(0);
  bohdanka  = add_word(0);
  maruska   = add_word(0);
  lada      = add_word(0);
  krasomila = add_word(0);
  osoba     = add_word(0);
  lotrando  = add_word(0);
  bobes     = add_word(0);
  jezislovo = add_word(0);
  jezinky   = add_word(0);
  certi     = add_word(0);
  lev       = add_word(0);

  add_sent(&konec);
  add_sent(&ukazjaz);
  add_sent(&daruj);
  add_sent(&seber);
  add_sent(&otevri);
  add_sent(&zavri);
  /**/add_sent(&prozkoumej);
  add_sent(&vylez);
  add_sent(&slez);
  add_sent(&oblec);
  add_sent(&svlec);
  add_sent(&spustzebr);
  add_sent(&nalej);
  add_sent(&vylej);
  add_sent(&mluv);
  add_sent(&privaz);
  add_sent(&posun);
  add_sent(&okoli);
  add_sent(&zapalsvicku);
  add_sent(&domu);
  add_sent(&snez);
}

void konec (int pocet, kq_word **slova)
{
  kql_exit();
}

void ukazjaz (int pocet, kq_word **slova)
{
  if(pocet == 0) zobrazjazyky();
  else warning("ukazjaz: spatny pocet slov");
}

void seber (int pocet, kq_word **slova)
{
  int i;
  kq_postava *oovl;

  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }
  oovl = ovlpost;
  ovlpost = panacek;

  if(pocet != 1) return;
  if(slova[0] == osoba || slova[0] == divka) slova[0] = princezna->slovo;
  if(brneni && slova[0] == brneni->slovo){
    if(brneni->inv) uzmaspredmet(brneni);
    else{
      predmetinv(brneni);
      sebralspredmet(brneni);
      znak = 's';
    }
    brnnastr = 0;
    ovlpost = oovl;
    return;
  }
  else if((i = seberslovo(slova[0])) > 0){
    if(slova[0] == pernicek->slovo) startjezi();
    if(aktupol == vdrevchal){
      krkstav = 0;
      kql_square(panacek, pol[5][1], 69, 91, 0, 0, 0);
      znak = 'z';
      panacek->smer = DOLU;
    }
  }
  else if(i < 0) popup_info("neni duvod");

  ovlpost = oovl;
}

void men_dvere (int jak)
{
  if(dvere_post->animstav + jak > 8 || dvere_post->animstav + jak < 0){
    znictimer(dvere_tim);
    dvere_tim = NULL;
    return;
  }

  if(dvere_post->submap){
    znicsubmap(dvere_post->submap);
    dvere_post->submap = NULL;
  }
  dvere_post->animstav += jak;
  if(dvere_post->animstav == 8)
    dvere_post->submap = vytvorsubmap(19, 74, 15, "h_dvere", 1, 0);

  zmenapost(dvere_post);
}

void otevri (int pocet, kq_word **slova)
{
  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }

  if(slova[0] == kokos->slovo){
    if(!kokos->inv){
      popup_info("nemas kokos");
      return;
    }
    if(!kokos->stav){
      popup_info("kok uz otv");
      return;
    }
    zmenprnazev(kokos, "kokpul");
    popup_info("otevrel kokos");
    predmetinv(mkozisek);
  }

  if(pocet == 1 && slova[0] == dvere){
    if(!dvere_post){
      popup_info("neni duvod");
      return;
    }
    if(aktupixel() != dosahpredmet){
      popup_info("_too far");
      return;
    }
    if(dvere_post->animstav >= 8){
      popup_info("opened door");
    }
    else{
      panacek->smer = NAHORU;
      panacek->xx = panacek->yy = 0;
      zmenapost(panacek);
    }

    if(dvere_tim) dvere_tim->parametr = pinint(1);
    else dvere_tim = vytvortimer(&men_dvere, pinint(1), 2, 0, 0, 1, 0);
  }
}

void zavri (int pocet, kq_word **slova)
{
  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }

  if(pocet != 1 || slova[0] != dvere || !dvere_post){
    popup_info("neni duvod");
    return;
  }

  if(aktupixel() != dosahpredmet){
    popup_info("_too far");
    return;
  }
  if(dvere_post->animstav <= 0){
    popup_info("closed door");
  }
  else{
    panacek->smer = NAHORU;
    panacek->xx = panacek->yy = 0;
    zmenapost(panacek);
  }

  if(dvere_tim) dvere_tim->parametr = pinint(-1);
  else dvere_tim = vytvortimer(&men_dvere, pinint(-1), 2, 0, 0, 1, 0);
}

void vylez (int pocet, kq_word **slova)
{
  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }
  if(strom->kontext<=0 && zebrik->slovo->kontext<=0){
    popup_info("vylez kam?");
    return;
  }
  if(strom->kontext<=0 && !zebrik->stav){
    if(pocet && slova[0]) popup_info("je srolovany");
    else popup_info("vylez kam?");
    return;
  }
  if(panacek->animace == lezeni){
    popup_info("zebr sipky");
    return;
  }
  if(!najdibarvu (dosahpredmet, panacek->x, panacek->y)){
    popup_info("_too far");
    return;
  }
  if(panacek->animace == brnanip){
    if(strom->kontext>0) popup_info("ne na str v brn");
    else popup_info("ne na zebr v brn");
    return;
  }

  if(strom->kontext>0){
    if(nastrome) popup_info("byl strom");
    else popup_info("je strom");
    hidepost(panacek);
    nastrome = 1;

    if(aktupol == pol[2][4] && brnnastr){
      brneni->slovo->kontext++;
      znak = 'b';
    }
    else znak = 's';
  }
  else{
    if(aktupol == skala3){
      kql_square(panacek, skal_zebr2, 23, 0,0,0,0);
      if(pol_prichfunc) pol_prichfunc(skala3, DOLU, skal_zebr2);
    }
    else{
      panacek->x = 89;
      panacek->y = 15;
      if(jezibaba) jezicekej();
    }
    zmenanip(panacek, lezeni);
    post_z(panacek, 0, 0.1, 49.2);
    anip_step(panacek);
    panacek->xx = panacek->yy = 0;
  }
}

void slez (int pocet, kq_word **slova)
{
  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }
  if(panacek->animace == lezeni){
    popup_info("zebr sipky");
    return;
  }
  if(!nastrome){
    if(pocet && slova[0] == strom) popup_info("nebyl strom");
    else if(pocet && slova[0] == zebrik->slovo) popup_info("nebyl zebr");
    else popup_info("slez odkud?");
    return;
  }
  popup_info("neni strom");
  panacek->xx = panacek->yy = 0;
  unhidepost(panacek);
  nastrome = 0;
  znak = 0;

  if(brneni && brnnastr && aktupol == pol[2][4]) brneni->slovo->kontext--;
}

void oblec (int pocet, kq_word **slova)
{
  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }
  if(slova[0] == mkozisek->slovo){
    popup_info("oblec kozisek");
    return;
  }
  if(panacek->animace == brnanip){
    popup_info("jsi v brn");
    return;
  }
  if(!brneni->inv){
    popup_info("nemas brn");
    return;
  }
  if(nastrome){
    popup_info("ne brn na str");
    return;
  }
  if(panacek->animace == lezeni){
    popup_info("ne brn na zebr");
    return;
  }
  if(panacek->animace != chozeni){
    predmetnull(brneni);
    popup_info("oblec uhas");
    return;
  }

  popup_info("v brneni");
  panacek->tim->cas = 10;
  zmenanip(panacek, brnanip);
}

void svlec (int pocet, kq_word **slova)
{
  if(slova[0] == mkozisek->slovo){
    popup_info("svlec kozisek");
    return;
  }
  if(!panacek || panacek->animace != brnanip){
    popup_info("nejsi v brn");
    return;
  }
  if(aktupixel() == ohen){
    popup_info("svlec shor");
    znicpost(panacek);
    ovlpost = panacek = NULL;
    return;
  }

  popup_info("mimo brneni");
  panacek->tim->cas = 3;
  zmenanip(panacek, chozeni);
}

void spustzebr (int pocet, kq_word **slova)
{
  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }
  if(zebrik->stav){
    popup_info("je spusteny");
    return;
  }
  if(!najdibarvu (dosahpredmet, panacek->x, panacek->y)){
    popup_info("_too far");
    return;
  }

  zmenprnazev(zebrik, "odrolzebr");
  predmetpol(zebrik, skala3,
	     162, 102, 0.2,
	      78, 101,   5);
}

void nalej (int pocet, kq_word **slova)
{
  if(pocet != 2) warning("nalej ma misto dvou parametru %d", pocet);

  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }
  if(kybl->stav){
    popup_info("uz mas vodu");
    return;
  }
  else if(panacek->animace != topeni && panacek->animace != vevode3 &&
	  panacek->animace != vevode2 && panacek->animace != vevode1 &&
	  (aktupol != pol[0][6] ||
	   aktupixel() != dosahpredmet)){
    popup_info("_too far");
    return;
  }
  else if(!kybl->inv){
    if(slova[0]) popup_info("nemas kybl");
    else popup_info("nalej kam?");
    return;
  }

  popup_info("nalil");
  if(aktupol == pol[0][6] && panacek->x < 52) zmenprnazev(kybl, "kybl+voda");
  else zmenprnazev(kybl, "kybl+vod");
  voda->kontext++;
}

void vylej (int pocet, kq_word **slova)
{
  if(pocet != 2) warning("vylej ma misto dvou parametru %d", pocet);

  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }
  if(!kybl->stav && slova[1]){
    popup_info("nemas vodu");
   return;
  }
  else if(!kybl->inv && slova[0]){
    popup_info("nemas kybl");
    return;
  }
  else if(!kybl->stav){
    popup_info("co vylit?");
    return;
  }

  if(!strcmp(kybl->nazev, "kybl+voda") && aktupol == peklo){
    znicwidget(peklohen);
    peklohen = NULL;
    while(prvpost != panacek) znicpost(prvpost);
    popup_info("zneskodneno peklo");
    certi->kontext = 0;
    osoba->kontext = 0;
    znak = 'x';
  }
  else if(kybl->stav && aktupol == peklo) popup_info("spatna voda");
  else popup_info("vylil");
  zmenprnazev(kybl, "kybl");
  voda->kontext--;
}

void daruj (int pocet, kq_word **slova)
{
  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }

  if(kral->kontext > 0){
    if(slova[0] == sluchatko->slovo){
      if(aktupixel() != dosahpredmet && (aktupixel() == zem || panacek->y > 28)){
	popup_info("_too far");
	return;
      }
      popup_info("vyhral jsi");
      kql_restart();
    }
    else popupwarning("kral bez zajmu", slova[0]->nazev);
    return;
  }
  if(krkavci->kontext > 0){
    if(slova[0] == pernicek->slovo){
      predmetnull(pernicek);
      promenujkrk();
    }
    else popupwarning("krkavci bez zajmu", slova[0]->nazev);
    return;
  }
  if(!jinapost || jinapost->hide){
    popupwarning("daruj komu?", slova[0]->nazev);
    return;
  }
  else if(smpixel(jinapost->submap, panacek->x, panacek->y) != dosahpredmet){
    popup_info("_too far");
    return;
  }
  else if(lotrando->kontext){
    predmetnull(slova[0]->informace.u.p);
    popupwarning("uloupil", slova[0]->nazev);
    znicpost(jinapost);
  }
  else if(aktupol == pol[7][0] && slova[0] == mkozisek->slovo){
    predmetnull(mkozisek);
    predmetinv(hvezdicka);
    popup_info("dostal hvezdu");
    makozisek = 1;
    zmenanip(jinapost, nactianip(9, 40, "mkozisek", 4, 0, 0, 0, 1));
    autopost(jinapost, NULL, 0, 0);
  }
  else if(aktupol == pol[2][2] && slova[0] == odsmolicka->slovo){
    predmetnull(odsmolicka);
    popup_info("bezel jelen");
    znak = 'x';
    znicpost(jinapost);
    predmetpol(kaminek, aktupol,
	       16, 57, 0,
	        1, 52, 5);
    jelen->kontext--;
    smolicek->kontext--;
  }
  else if(aktupol == pol[3][6] && slova[0] == slanka->slovo){
    predmetnull(slanka);
    dostalkyt = 1;
    popup_info("dostal kytku");
    autopost(jinapost, NULL, 0, 0);
    predmetinv(kytka);
  }
  else if(aktupol == pol[6][6] && slova[0] == kytka->slovo){
    predmetnull(kytka);
    dostalsvic = 1;
    popup_info("dostal svicku");
    autopost(jinapost, auto_clever, 0, 0);
    jinapost->chyt_vzdal = 0;
    setchytsour(jinapost, 35, 56);
    predmetinv(svicka);
  }
  else{
    if(aktupol == pol[7][0] || aktupol == pol[3][6] || aktupol == pol[6][6])
      popupwarning("princezna bez zajmu", slova[0]->nazev);
    if(aktupol == pol[2][2])
      popupwarning("jelen bez zajmu", slova[0]->nazev);
  }
}

static char zkusmluvit (kq_word *skym)
{
  if(skym->kontext <= 0) return 0;
  popupoutput("talk", skym, 0.5, 0.7, 0.1, 0.5);
  popupoutput("talk2", skym, 0.5, 0.7, 0.9, 0.5);
  popupoutput("talk3", skym, 0.5, 0.7, 0.1, 0.5);
  return 1;
}

void mluv (int pocet, kq_word **slova)
{
  if(pocet < 1){
    warning("funkce mluv ma malo parametru (pocet < 1)");
    return;
  }

  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }

  if(slova[0] == sluchatko->slovo){
    if(!sluchatko->inv) popup_info("nemas sluchatko");
    popup_info("sluchatko nemluvi");
    return;
  }
  if(jinapost){
    if(smpixel(jinapost->submap, panacek->x, panacek->y) != dosahpredmet){
      popup_info("_too far");
      return;
    }

    if(jelen->kontext > 0) popup_info("jelen nemluvi");
    else if(krasomila->kontext > 0) popup_info("krasomila nemluvi");
    else if(lotrando->kontext > 0) popup_info("lotrando nemluvi");
    else if(!(zkusmluvit(maruska) ||
	      zkusmluvit(lada) || zkusmluvit(krasomila)))
      warning("neznama osoba");
  }
  else{
    if(certi->kontext > 0) popup_info("certi nemluvi");
    else if(krkavci->kontext > 0) popup_info("krkavci nemluvi");
    else if(lev->kontext > 0 && (slova[0] == lev || divka->kontext <= 0))
      popup_info("lvi nemluvi");
    else if(aktupol == lvi) popup_info("spici nemluvi");
    else if(jezislovo->kontext) popup_info("jezibaba nemluvi");
    else{
      if(aktupixel() != dosahpredmet &&
	 (kral->kontext <= 0 || aktupixel() == zem || panacek->y > 28)){
	if(jezinky->kontext > 0 && slova[0] != smolicek){
	  popup_info("jezinky nemluvi");
	  return;
	}
	popup_info("_too far");
	return;
      }

      if(smolicek->kontext > 0){
	if(slova[0] == jezinky){
	  popup_info("jezinky nemluvi");
	  return;
	}
	if(smoldal){
	  popupoutput("uz smol dal", NULL, 0.7, 0.3, 0.5, 0.1);
	  return;
	}
	popupoutput("smol dava", NULL, 0.7, 0.3, 0.5, 0.1);
	smoldal = 1;
	predmetinv(odsmolicka);
      }
      else if(!(zkusmluvit(bohdanka) || zkusmluvit(kral) || zkusmluvit(bobes)))
	warning("neznama osoba");
    }
  }
}

void snez (int pocet, kq_word **slova)
{
  if(slova[0] == tresne){
    if(aktupol != pol[2][0] || aktupixel() != dosahpredmet){
      popup_info("_too far");
      return;
    }
    popup_info("ji tresne");
  }
  else if(slova[0] == pernicek->slovo){
    if(!pernicek->inv){
      popup_info("nemas pernik");
      return;
    }
    predmetnull(pernicek);
    popup_info("snedl pernik");
  }
  else popup_info("neni duvod");
}

void okoli (int pocet, kq_word **slova)
{
  char *str1, *str2, pomstr[3];

  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }

  if(aktupol->predmety){
    if(aktupol->predmety->stav) str1 = joinstrings(aktupol->jmpixmap, ".1", NULL);
    else str1 = joinstrings(aktupol->jmpixmap, ".0", NULL);
  }
  else str1 = aktupol->jmpixmap;

  if(znak){
    pomstr[0] = '_';
    pomstr[1] = znak;
    pomstr[2] = 0;
    str2 = joinstrings(str1, pomstr, NULL);
  }
  else str2 = str1;

  popup_info(str2);

  if(str2 != str1) free(str2);
  if(str1 != aktupol->jmpixmap) free(str1);
}

void zapalsvicku (int pocet, kq_word **slova)
{
  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }
  if(!svicka->inv || svicka->stav){
    popup_info("neni duvod");
    return;
  }
  popup_info("zapaluje");
  zmenprnazev(svicka, "zapsvic");
}

void domu (int pocet, kq_word **slova)
{
  if(!panacek){
    popup_info("nemuzes nic");
    return;
  }
  if(!sluchatko->inv){
    popup_info("jak domu?");
    return;
  }
  unhidepost(panacek);
  nastrome = 0;
  znak = 0;
  if(panacek->animace == lezeni) zmenanip(panacek, chozeni);
  normal_z(panacek, NULL, NULL);
  if(telepost){
    znicpost(telepost);
    telepost = NULL;
  }
  if(teletim){
    znictimer(teletim);
    teletim = NULL;
  }
  ovlpost = panacek;
  kql_square(panacek, vzamku2, 58, 20, 0, 0, 0);
  panacek->barvy = 1;
}

void prozkoumej (int pocet, kq_word **slova)
{
  //  printf("prozkoumej jeste neni implementovano\n");
  popup_info("neni duvod");
}
