Tento modul e peveden labelku ve zdrojku na text, m spolu
s~modulem \vizmod[input] zaizuje monost vce jazyk. V knihovn
pomocnch funkc pouvm pouze takov labelky, kter zanaj na
podtrtko. Konkrtn to jsou:

\begtt
_restart?  ::  Otzka, zda to hr s restartem mysl vn
_help      ::  Npovda zobrazen kliknutm my nebo klvesou F1
_about     ::  Informace zobrazen pi prvnm sputn nebo klvesou F10
_empty inv ::  Oznmen, e je invent przdn

_save      ::  Nadpis vyskoenho okna p ukldn pozice
_load      ::  Nadpis vyskoenho okna p natn pozice
_languages ::  Nadpis vbru jazyk

_unknown word     :: Varovn, e program nezn slovo #
_bad kontext      :: Varovn, e slovo # nem kladn kontext
_unknown sentence :: Oznmen, e program nepochopil vtu
_unknown output   :: Varovn, e program nezn output #

_same language :: oznmen, e jazyk, do kterho hr chce pepnout,
                  u je nastaven
_return to language :: npovda, jak se vrtit k pvodnmu jazyku
_language start     :: informace o tom, e bylo prv pepnuto
                       do tohoto jazyka

_uz mas   ::    Varovn, e pedmt #, kter chce hr sebrat,
                je v inventi

_bere :predmet: Oznmen, e hr prv sebral pedmt #
_too far  ::    Oznmen, e je hr pli daleko od pedmtu,
                kter chce vzt

_inv       :predmet: Nzev predmetu se stavem false
__inv      :predmet: Nzev pedmtu se stavem true
_inv_look  :predmet: Povdn o pedmtu se
                     stavem false (pi jeho zobrazen)
__inv_look :predmet: Povdn o pedmtu se
                     stavem true (pi jeho zobrazen)
\endtt

Pod uritm stringem me bt uloen ukazatel na datov typ \dg
kq_output.

\inst kq_output

Hledan string je v~poloce "str". Poloka "orig" je vyuita pi
mazn outputu. Dky poloce "next" mohu tyto outputy adit do
seznamu. Posledn poloka je "slovo". Toti nemusm napsat jen
labelk, ale k~nmu mohu napsat i njak slovo (ukazatel na
"kq_word"). Tato poloka me bt (a bv) "NULL".

Funkce, kter pevd string a slovo na vstupn string, je
\dg [char *]outputstring(). Tato funkce vyhled pomoc hashe a prvnho
parametru pslun seznam a v~nm nhodn vybere prvek, u~kter se
shoduje poloka "slovo" s~druhm parametrem funkce "outputstring". To,
co funkce vrt je string, kter nen radno mazat (free). Pokud nen
nalezen pislun labelk s~pslunm slovem, je vrcen "NULL".

\insf outputstring

\subsec Vyskakovac output

Nejastj operace se zskanm stringem je jeho zobrazen pomoc
funkce "popupstring". To dl funkce \dg [char] popupoutput(). Pokud
nen hledan output nalezen, vysko okno s~varovnm a vrt nulu. 
Nulu vrt i v~ppad, e je okno zrueno klvesou Escape. 
Jinak vrt jedniku.

\insf popupoutput

Dal funkce, kter situaci jet zjednoduuje, je \dg [char]
popup_info(). Tato funkce u vyaduje jen labelk. Rozmry a umstn
okna ur z~hodnot "DEF_POP_SIRKA", "DEF_POP_VYSKA",
"DEF_POP_X", "DEF_POP_Y", a jako slovo zvol "NULL".

\insf popup_info

Posledn output funkce, kter vysko s~oknem, je \dg [void]
popupwarning(). Tato funkce m podobnou funkci jako "popup_info", ale
krom labelku m jet jeden parametr. Tento parametr je string,
kter se vepe do nalezenho stringu tam, kde je znak k. Zde je
teba jet eit situaci, kdy nen zanesen labelk "_unknown output",
protoe to je labelk, kter je pouit v~ppad, e nen njak
labelk nalezen.

\insf popupwarning

\subsec Natn outputu

Output je podobn jako input nattn ze souboru. Zkladn princip je
ten, e labelk je napsn na zatku dku a text, kter je pod nm
odsazen doprava, je vstupn string. Dle se lehce opim po
\TeX ovskm token procesoru tm, e vce mezer u~sebe se promn
v~jednu a mezery na zatku a konci dku jsou ignorovny a
enter je povaovn za mezeru. Przdn dek je povaovn za skuten
konec dku, ale przdn dky tsn ped labelkem jsou ignorovny.

Pi pedn tohoto stringu funkci "popupstring" je text opt rozlmn
podle velikosti okna. Tato funkce navc z~vlnky udl nezalomitelnou
mezeru, take moduly output a popup vlastn tvo takov skoro \TeX.
Pokud je na zatku souboru njak odsazen text, je ignorovn.

Nejjednodu pklad outputu tedy vypad takto:

\begtt

  Co to del? Neti tento soubor.

labelik
  Vtej na scn

  Tady  tento  text se zobraz v~okamiku, kdy se
  ve   zdrojku   objev   popup_info("labelik"),
  piem text "Vtej na scn" (ovem pouze jeho
  prvn vskyt) bude na samostatnm dku
labelik  2
  I ty kujne, e jsi napsal popup_info("labelik 2")

\endtt

Takov texty maj v~poloce "slovo" "NULL". Pokud tam chcete dostat
njak slovo, napite za labelk dvojteku a na ten sam dek njak
slovo z~inputu. S~tmto slovem mus bt program obeznmen ze souboru
input a navc to slovo mus bt uloeno do "kq_word". Kdy za
dvojtekou nic nen, tak je slovo "NULL", stejn jako by tam dvojteka
nebyla.

Za slovem se me vyskytovat dal dvojteka a pak u me pokraovat
text. dek za dvojtekou vak nen nikdy povaovn jako przdn.

Dle je mon piadit vce labelkm stejn text. To se
udl tak, e se labelky oddl rkami.

Labelk s~dvojtekou a slovem zde tvo ucelen prvek, kter se
oddluje rkami, take napklad

\begtt
labelik, labelik 2: slovo: Text.
\endtt

je to sam jako

\begtt
labelik  :: Text.
labelik 2: slovo: Text.
\endtt

Dle jsou za rkou ignorovny mezery, tabeltory a entery, take je
mon zalomit seznam labelk na vce dk.

Funkce, kter tento soubor pete, se jmenuje \dg [void] nactioutput().

\insf nactioutput

Poloka "orig" ve struktue "kq_word" udv, jestli pi uvolovn
z~pamti m bt uvolnn i string. Je to tedy nastaveno na false, pokud
byl labelk napsn za rkou.
