Tento modul obsahuje funkce, kter se spust pi zmn 
\cite barvy[m:color]. Dle je zde
funkce \dg [void] nactigbarvy(), kter nastav barvy, kter
jsou globln, tedy nepslu pouze njakmu polku.

\insf nactigbarvy

Barva \dg [kq_color *]zem je nejbnj barva, na kter panek stoj
bez jakchkoli zvltnch ink. Barva \dg [kq_color *]zed je barva,
na kterou panek neme vstoupit, ale nic se pi pokusu o~to
nestane.

Funkce "aktupixel" vrt barvu z~mapy "mapa" v~mst, kde prv stoj
"panacek".

\insf aktupixel

Funkce \dg [void] normal_z() piad postav Z-kovou
souadnici, kter se pot jako Y-ov souadnice plus $0.5$. Dostane
dva zbyten parametry barev, aby mohla bt pouita jako funkce
pchodu nebo odchodu z~barvy na polku "pol[6][6]".

\insf normal_z

Funkce \dg [void] nuluj_z() nastav postav nulovou souadnici. Tato
funkce tak nachz uplatnn na "pol[6][6]".

\insf nuluj_z

Pi vstupu do vody, ve kter se panek brod (nebo plave) je zavolna
jedna z~funkc \dg [void] brodi1(), \dg [void] brodi2(),
\dg [void] brodi3(), \dg [void] plave().

\ifirst {kra_barvy.c}{brodi1 (}{plavani}{++}

Tyto funkce zavolaj funkci \dl [void] dovody(), kter nastav
pankovi pslunou animaci. V~ppad, e m na sob panek brnn,
o~nj pijde.

\insf dovody

Krom vody, ve kter se d brodit, je ve he jet voda, kde panka
un proud. Barvy tto vody jsou tyi. Barva
\dg [kq_color *]nebvoda1 thne panka doleva nahoru, barva
\dg [kq_color *]nebvoda2 thne panka doprava nahoru, barva
\dg [kq_color *]nebvoda3 thne panka doprava dol a barva
\dg [kq_color *]nebvoda4 ho thne doleva dol. To, e je barva jednou
z~tchto ty, poznm tm, e m v~poloce "prichfunc" funkci
\dg [void] topise(). Tato funkce d pankovi sprvn smr a animaci a
znemon jeho ovldn. Tak mu piad nulovou Z-kovou souadnici,
aby proplouval pod mostem.

\insf topise

Pi odchodu z~barvy vody je obvykle nastavena pankovi opt jeho
pvodn animace, co provede funkce \dg [void] sucho().
Aby byla animace "topeni" sprvn animovna, je teba, aby pi zmn
barvy nebezpen vody, nebyla postav ani na okamik piazena jin
animace, protoe by to restartovalo timer, kter topen
animuje.

\insf sucho

Kdy panek vstoup na hnd beh nebezpen eky (barva
\dg [kq_color *]breh `), je vyhledno
nejbli polko, ve kterm je nebezpen voda, a na toto polko je
panek pesunut. To zad funkce \dg [void] paddovody().

\insf paddovody

Kdy se panek sna vejt na pdu s~kytikami, spust se funkce
\dg [void] bachakytky(), kter vysko s~oknem, e tam nem chodit.

\insf bachakytky

Na polku "pol[[2][3]" se vyskytuje submapa \dg [kq_submap *]most_sm,
kter je obvykle schovan, aby mohl panek chodit za mostem a plavat
pod mostem. Kdy vejde na most, spust se funkce
\dg [void] prich_most(), kter submapu odschov a d pankovi takovou
Z-kovou souadnici, aby byl vidt ped mostem.

\insf prich_most

Kdy odejdu z~mostu, vrt se Z-kov souadnice zptky a "most_sm" se
opt schov. To provede funkce \dg [void] odch_most(). 
V~ppad, e panek spadl z~mostu do vody, je posunut
dol.

\insf odch_most

Dle stoj za povimnut, co se stane pi vstoupen panka na
teleport. V~takovm pipad se spust timer \dg [kq_timer *]teletim().

\insf telestart

Pi odejit z~teleportu je "teletim" opt znien.

\insf teleend

Timer "teletim" opakovan spout funkci \dg [void]
teleportuj(). Nejprve ji spust za as mezi padesti a dv st
padesti framy. Dle u je spoutn jednou za tyi framy. Kdy je
funkce teleportuj sputna poprv (co pozn
podle toho, e jet nen vytvoen "telepost"), vytvo postavu
\dg [kq_postav] telepost na stejnm mst, jako je panek, a znemon
pankovi se hbat. Kdy m postava "telepost" smr "NAHORU", znamen
to, e jej stav animace m stoupat. Kdy u stav animace doshne
sla 12, zmn se polko a do smru "telepost" je dosazeno "DOLU",
take se stav animace bude nadle sniovat. Kdy se sn na nulu,
zni telepost a umon pankovi se opt pohybovat.

\insf teleportuj

Kdy panek vejde pod kokos, spust se funkce
\dg [void] padejkokos(), kter zalo timer, kter opakovan posouv
kokos k~zemi. Funkce "padejkokos" navc uprav pedmt "kokos" tak,
aby se, kdy odejdu a vrtm se, leel ji kokos na zemi.

\insf padejkokos

Funkce \dg [void] kokpadstep() posouva kokos smrem k~zemi. Pi padn
kokosu jsou specifick dva okamiky. Prvn je, kdy poloka
"opakovani" aktulnho timeru je rovna dvaceti. V~takovm ppad je
vytvoena submapa, kter brn pankovi vstoupit do msta, kde pad
kokos. Pokud se ji panek pod kokosem nalz, je znien. Druh
vznamn okamik je, kdy poloka "opakovani" timeru je rovna
nule. V~takovm ppad je kokos nakpnut a je mu piazena ta dve
vytvoen submapa, take ji jde sebrat.

\insf kokpadstep

Kdy panek vejde na okraj skly, ebku, schod nebo
jmy, spust se funkce \dg [void] skalopada(), kter zad, e
panek spadne. Tato funkce
zru monost ovldat panka a do promnn "panacek" dosad
NULL. Pankovi piad animaci "padani" a zlokln ho. Pro
padn jsou ti barvy, kter se ovem li jen Z-kovou souadnic,
kter se pankovi piad. V~barv \dg [kq_color *]skalopad1 nastavm
"z = -3", v~barv \dg [kq_color *]skalopad2 nastavm "z = -1" a
v~barv \dg [kq_color *]skalopad3 nastavm "z = 1". Funkce "skalopada"
je zavolna i na spodku ebku. V~takovm ppad vak panek
jednodue sesko (objev se dole).

\insf skalopada

Kdyz panek vstoup do plamen na skle
(barva \dg [kq_color *]ohen `), je zavolana funkce
\dg [void] shor(), kter panka zlikviduje za pedpokladu, e na
sob nem brnen. Tato funkce je zavolna, i kdy do plamen vstoup
jeibaba. V~takovm ppad vak penech prci funkci "jezishor".

\insf shor

Kdy se panek pibl ke lvm, spust se funkce
\dg [void] levchyt() a jsou dv monosti, co se
stane. Pokud m u~sebe zaplenou svku, tak lvi zkamen a pankovi
vypadne z~invente kamnek. Pokud zaplenou svku nem, je znien.

\insf levchyt

Funkce \dg [void] barvapolic() je pouita pro pechod na jin polko
jinak ne pes okraj. Tato funkce je vyuita pro vstup do hradu, do
devn chaloupky, do jeskyn a z~jezkyn a tak pro pd ped peklo.

\insf barvapolic

Funkce \dg [void] predTV() zobraz krlovo napomenut
o~peken ped televiz.

\insf predTV
